<?php
//header('Content-type: text/plain');

class SqliteDb extends SQLite3
{
    function __construct()
    {
        $this->open('test.db');
        //$this->createTable();
    }
    
    function createTable(){
        //Création De La Table
        $this->exec('DROP TABLE Correct');
        $this->exec('CREATE TABLE Correct ( question STRING, reponse STRING, type STRING, fonctionCorrect STRING,testUser STRING)');
        
        //Question 1
        $type = 'query';
        $fonctionCorrect = null;
        $testU = null;
        $reponse = 'SELECT count(*) FROM stats WHERE prenomnoms=\'Kevin Durant\' ';       
        $q = "INSERT INTO Correct VALUES ('Trouver le nombre de matchs joués par Kevin Durant', ? ,?,?,?)";
        $stmt = $this->prepare($q);
        $stmt->bindParam(1,$reponse);
        $stmt->bindParam(2,$type);
        $stmt->bindParam(3,$fonctionCorrect);
        $stmt->bindParam(4,$testU);
        $stmt->execute();
                
        //Question 2  
        $type = 'query';    
        $fonctionCorrect = null;
        $testU = null; 
        $reponse = ' SELECT prenomnoms,datematch,points,equipeadverse FROM stats WHERE points = (SELECT max(points) FROM stats)';
        $q = "INSERT INTO Correct VALUES ('Lister le(s) joueur(s) ayant marqué le plus de points dans la saison en indiquant son nom, la date du match, le nombre de points, l équipe adverse et le nombre de points marqués ', ? ,?,?,?)";
        $stmt = $this->prepare($q);
        $stmt->bindParam(1,$reponse);
        $stmt->bindParam(2,$type);
        $stmt->bindParam(3,$fonctionCorrect);
        $stmt->bindParam(4,$testU);
        $stmt->execute();
        
        //Question 3   
        $type = 'query';   
        $fonctionCorrect = null;
        $testU = null; 
        $reponse = ' SELECT prenomnoms, COUNT(*) FROM  stats GROUP BY prenomnoms HAVING count(*) = (SELECT MAX(c) FROM (SELECT COUNT(*) AS c FROM stats GROUP BY prenomnoms))';
        $q = "INSERT INTO Correct VALUES ('Lister le(s) joueur(s) ayant joué le plus de match pendant la saison', ? ,?,?,?)";
        $stmt = $this->prepare($q);
        $stmt->bindParam(1,$reponse);
        $stmt->bindParam(2,$type);
        $stmt->bindParam(3,$fonctionCorrect);
        $stmt->bindParam(4,$testU);
        $stmt->execute();
        
        //Question 5
        $type = 'query';
        $fonctionCorrect = null;
        $testU = null;
        $reponse = 'SELECT nom FROM Equipe, Stats WHERE datematch = \'30-OCT-17\'  AND prenomnoms = \'Kevin Durant\'  AND idequipe = CASE WHEN locationjoueur = \'Away\' THEN equipeadverse WHEN locationjoueur = \'Home\' THEN equipejoueur END ';
        $q = "INSERT INTO Correct VALUES ('Déterminer pour Kevin Durant pour le match du 30-oct-17 quelle est l équipe qui joue à domicile', ?,?,?,? )";
        $stmt = $this->prepare($q);
        $stmt->bindParam(1,$reponse);
        $stmt->bindParam(2,$type);
        $stmt->bindParam(3,$fonctionCorrect);
        $stmt->bindParam(4,$testU);
        
        $stmt->execute();
        
        //Question 6
        $this->joueurEtDateRandom($joueurRandom, $dateRandom);
        $type = 'fonction';
        $fonctionCorrect = 'CREATE OR REPLACE FUNCTION fpointsmarques(date_match IN VARCHAR2, joueur IN VARCHAR2 ) RETURN NUMBER IS nbPoints NUMBER ; BEGIN SELECT points INTO nbPoints FROM stats WHERE datematch = date_match AND prenomnoms=joueur; RETURN nbPoints; END;' ;
        $reponse = 'SELECT fpointsmarques(\''.$dateRandom.'\', \''.$joueurRandom.'\') FROM DUAL';       
        $testU =    'SELECT pointsmarques(\''.$dateRandom.'\', \''.$joueurRandom.'\') FROM DUAL' ;        
        $q = "INSERT INTO Correct VALUES ('Ecrire une fonction pointsmarques qui détermine pour une date de match et un joueur donnés quelle est le nombre de points marqués par ce joueur', ?,?,?,? )";
        $stmt = $this->prepare($q);
        $stmt->bindParam(1,$reponse);
        $stmt->bindParam(2,$type);
        $stmt->bindParam(3,$fonctionCorrect);
        $stmt->bindParam(4,$testU);
        $stmt->execute();
        
         //Question 9
       /* $type = 'tablemodification';
        $fonctionCorrect = 'idjoueur';
        $testU = null;
        $reponse = ' SELECT  column_name FROM all_tab_columns WHERE table_name = \'JOUEUR\' ';
        $q = "INSERT INTO Correct VALUES ('Déterminer pour Kevin Durant pour le match du 30-oct-17 quelle est l équipe qui joue à domicile', ?,?,?,? )";
        $stmt = $this->prepare($q);
        $stmt->bindParam(1,$reponse);
        $stmt->bindParam(2,$type);
        $stmt->bindParam(3,$fonctionCorrect);
        $stmt->bindParam(4,$testU);
        
        $stmt->execute();*/
    }
    
    function createLogin(){
        $mdp = password_hash('mdptest', PASSWORD_DEFAULT);
        $username = 'test';
        $this->exec('DROP TABLE login');
        $this->exec('CREATE TABLE login ( username STRING, password STRING');
        
        $stmt = $this->prepare("INSERT INTO login VALUES(? , ?)");
        $stmt->bindParam(1, $username);
        $stmt->bindParam(2, $mdp);
        $stmt->execute();        
    }
    
    function joueurEtDateRandom(&$nomRandom, &$dateRandom){
        $conn = oci_connect('u_prems', '123456','localhost/orcl');
        $listeJoueurQuery = oci_parse($conn, 'SELECT prenomnoms,datematch FROM stats');
        oci_execute($listeJoueurQuery);
        $listeJoueurRows = oci_fetch_all($listeJoueurQuery, $listeJoueurArray);  
        //print_r($listeJoueurArray);
        $rand_keys = array_rand($listeJoueurArray['PRENOMNOMS'], 1);
        $nomRandom =  $listeJoueurArray['PRENOMNOMS'][$rand_keys];  
        $dateRandom = $listeJoueurArray['DATEMATCH'][$rand_keys];
    }

}

